unit Login;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  Borland.Eco.ObjectRepresentation,
  Borland.Eco.Handles, EcoIIIAuthenticationAspNetEcoSpace, Package_1Unit;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure Button1_Click(sender: System.Object; e: System.EventArgs);
    procedure Button2_Click(sender: System.Object; e: System.EventArgs);
  strict protected  
    rhRoot: Borland.Eco.Handles.ReferenceHandle;
    Label1: System.Web.UI.WebControls.Label;
    Label2: System.Web.UI.WebControls.Label;
    tbxLogin: System.Web.UI.WebControls.TextBox;
    tbxSenha: System.Web.UI.WebControls.TextBox;
    btnEntrar: System.Web.UI.WebControls.Button;
    ehUsuario: Borland.Eco.Handles.ExpressionHandle;
    btnNovoUsuario: System.Web.UI.WebControls.Button;
  {$ENDREGION}
  strict private
    fEcoSpace: TEcoIIIAuthenticationAspNetEcoSpace;
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
    procedure Page_Unload(sender: System.Object; e: System.EventArgs);
  strict protected
    procedure OnInit(e: EventArgs); override;
    function get_EcoSpace: TEcoIIIAuthenticationAspNetEcoSpace;
    procedure DoneWithEcoSpace;
    property EcoSpace: TEcoIIIAuthenticationAspNetEcoSpace read get_EcoSpace;
    {$REGION 'Utility Methods'}
    procedure UpdateDatabase;
    function IdForObject(Obj: IObject): string;
    function ObjectForId(Id: string): IObjectInstance;
    {$ENDREGION}
    {$REGION 'DataGrid Events'}
    procedure DataGrid_DeleteCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
    procedure DataGrid_EditCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
    procedure DataGrid_UpdateCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
    procedure DataGrid_CancelCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
    {$endregion}
  public
    procedure DataBind; override;
  end;

implementation

uses
  Borland.Eco.Services, EcoSpaceProvider, System.Web.Security, 
  System.Security.Principal;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Self.rhRoot := Borland.Eco.Handles.ReferenceHandle.Create;
  Self.ehUsuario := Borland.Eco.Handles.ExpressionHandle.Create;
  Include(Self.btnEntrar.Click, Self.Button1_Click);
  Include(Self.btnNovoUsuario.Click, Self.Button2_Click);
  // 
  // rhRoot
  // 
  Self.rhRoot.EcoSpaceType := TypeOf(EcoIIIAuthenticationAspNetEcoSpace.TEcoIIIAuthenticationAspNetEcoSpace);
  // 
  // ehUsuario
  // 
  Self.ehUsuario.RootHandle := Self.rhRoot;
  Include(Self.Unload, Self.Page_Unload);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
var
  Id: string;
begin
  EcoSpace.Active := True;
  Id := Request.Params['RootId'];
  if Assigned(Id) and (Id <> '') then
    rhRoot.SetElement(ObjectForId(Id));
  if not IsPostBack then
    DataBind;
  // TODO: Put user code to initialize the page here
end;

procedure TWebForm1.Page_Unload(sender: System.Object; e: System.EventArgs);
begin
  DoneWithEcoSpace();
end;

procedure TWebForm1.DataBind;
begin
  ElementHandle.EnsureAllBindingLists;
  inherited DataBind;
end;

procedure TWebForm1.Button2_Click(sender: System.Object; e: System.EventArgs);
begin
  Response.Redirect('NovoUsuario.aspx');
end;

procedure TWebForm1.Button1_Click(sender: System.Object; e: System.EventArgs);
var
  oPerfil: Perfil;
  oUsuario: Usuario;
  strPerfis: string;
  Ticket: FormsAuthenticationTicket;
  Identity: FormsIdentity;
  Generic: GenericPrincipal;
  Element: IElement;
  encTicket: string;
begin
  ehUsuario.Expression :=
    'Usuario.allInstances->select(Email='''+tbxLogin.Text+''')';

  for Element in ehUsuario.Element.GetAsCollection do
     oUsuario := Element.AsObject as Usuario;

  if Assigned(oUsuario) then
  begin
    if (oUsuario.Email = tbxLogin.Text) and
               (oUsuario.Senha = tbxSenha.Text) then
    begin
      strPerfis := oUsuario.Email + '|' + oUsuario.Senha;

      Session['USUARIO'] := IdForObject(oUsuario.AsIObject);

      for oPerfil in oUsuario.Perfils do
        strPerfis := strPerfis + '|' + oPerfil.Nome;

      Ticket := FormsAuthenticationTicket.Create(
                1,
                oUsuario.Email,
                System.DateTime.Now,
                System.DateTime.Now.AddMinutes(30),
                false,
                strPerfis,
                FormsAuthentication.FormsCookiePath);
      Identity := FormsIdentity.Create(Ticket);

      encTicket := FormsAuthentication.Encrypt(ticket);
      Response.Cookies.Add(HttpCookie.Create(FormsAuthentication.FormsCookieName, encTicket));

      Generic := GenericPrincipal.Create(Identity, [strPerfis]);
      HttpContext.Current.User := Generic;
      Response.Redirect
          (System.&String.Format('Index.aspx?rootid={0}',
                [IdForObject(oUsuario.AsIObject)]));
    end
    else
      RegisterClientScriptBlock('','<script>alert(''Senha e/ou usurio invlido.'')</script>');
  end;
end;

{$REGION 'Utility Methods'}
procedure TWebForm1.UpdateDatabase;
var
  PersistenceService: IPersistenceService;
  DirtyListService: IDirtyListService;
begin
  PersistenceService := EcoSpace.GetEcoService(typeof(IPersistenceService)) as IPersistenceService;
  DirtyListService := EcoSpace.GetEcoService(typeof(IDirtyListService)) as IDirtyListService;
  PersistenceService.UpdateDatabaseWithList(DirtyListService.AllDirtyObjects());
end;

function TWebForm1.IdForObject(Obj: IObject): string;
var
  IdService: IExternalIdService;
begin
  IdService := EcoSpace.GetEcoService(typeof(IExternalIdService)) as IExternalIdService;
  Result := IdService.IdForObject(Obj);
end;

function TWebForm1.ObjectForId(Id: string): IObjectInstance;
var
  IdService: IExternalIdService;
begin
  IdService := EcoSpace.GetEcoService(typeof(IExternalIdService)) as IExternalIdService;
  Result := IdService.ObjectForId(Id);
end;

{$ENDREGION}

{$REGION 'DataGrid Events'}

// The following code is useful if the form contains a System.Web.UI.Datagrid;
// It assumes that the elementhandle acting as a datasource has
// AddExternalId = true, and that datagrid.DataKeyField = "ExternalId"

procedure TWebForm1.DataGrid_DeleteCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
var
  SourceGrid: DataGrid;
  Id: string;
  ToDelete: IObjectInstance;
begin
  SourceGrid := source as DataGrid;
  Id := SourceGrid.DataKeys[e.Item.ItemIndex].ToString;
  ToDelete := ObjectForId(Id);
  if Assigned(ToDelete) then
    ToDelete.Delete;
  UpdateDatabase;
  DataBind;
end;

procedure TWebForm1.DataGrid_EditCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
begin
  (source as DataGrid).EditItemIndex := e.Item.ItemIndex;
  DataBind;
end;

procedure TWebForm1.DataGrid_UpdateCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
var
  SourceGrid: DataGrid;
  Id: string;
  Row: TObject;
  Eh: ElementHandle;
  ColIndex: Integer;
  Col: BoundColumn;
begin
  SourceGrid := source as DataGrid;
  Id := SourceGrid.DataKeys[e.Item.ItemIndex].ToString;
  SourceGrid.DataBind(); // To set DataSource
  Eh := SourceGrid.DataSource as ElementHandle;
  Row := eh.RenderElement(ObjectForId(Id));
  for colIndex := 0 to SourceGrid.Columns.Count-1 do
  begin
    Col := BoundColumn(SourceGrid.Columns[colIndex]);
    if Assigned(Col) and (not Col.ReadOnly) then
      eh.SetRenderedElementProperty(row, Col.DataField, (e.Item.Cells[colIndex].Controls[0] as TextBox).Text, true);
  end;
  UpdateDatabase;
  SourceGrid.EditItemIndex := -1;
  DataBind;
end;

procedure TWebForm1.DataGrid_CancelCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
begin
  (source as DataGrid).EditItemIndex := -1;
  DataBind;
end;
{$ENDREGION}

procedure TWebForm1.OnInit(e: EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  inherited OnInit(e);
end;

function TWebForm1.get_EcoSpace: TEcoIIIAuthenticationAspNetEcoSpace;
begin
  if not Assigned(fEcoSpace) then
  begin
    fEcoSpace := TEcoSpaceProvider.GetEcoSpace;
    rhRoot.EcoSpace := fEcoSpace;
    // Set additional root handles here and in DoneWithEcoSpace
  end;
  Result := fEcoSpace;
end;

procedure TWebForm1.DoneWithEcoSpace;
begin
  if not Assigned(fEcoSpace) then
    Exit;
  rhRoot.EcoSpace := nil;
  rhRoot.SetElement(nil);
  // Clear all other references to ecoSpace or its contents here.
  // Otherwise it is not safe to return it to a pool.
  TEcoSpaceProvider.ReturnEcoSpace(fEcoSpace);
  fEcoSpace := nil;
end;

end.

